//----------------------------------------------------------------
//Code Art.
//
//ļ:
//
//  : jianyi0115@163.com
//: 2008-1-19
//
//޶¼: 
//
//----------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls; 
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using Microsoft.SharePoint;


[assembly: TagPrefix("CodeArt.SharePoint.SmartForm", "smartform")]
namespace CodeArt.SharePoint.SmartForm
{   
      
    /// <summary>
    /// webpart
    /// </summary>
    public abstract class BaseSPWebPart : System.Web.UI.WebControls.WebParts.WebPart 
    {

        protected const string WEB_NAME_QUERYSTRING_KEY = "__WebName";
        protected const string LIST_NAME_QUERYSTRING_KEY = "__ListName";

        protected string GetQueryString(string key)
        {
            return Page.Request.QueryString[key] != null ? Page.Request.QueryString[key] : "";
        }             

   
        #region Դ

        protected SPWeb Web
        {
            get
            {
                return this.GetCurrentSPWeb();
            }
        }

        private string _WebName;        
        public string WebName
        {
            get { return _WebName; }
            set { _WebName = value; }
        }

        private string _SiteUrl;
        public string SiteUrl
        {
            get { return _SiteUrl; }
            set { _SiteUrl = value; }
        }

        #endregion

        #region 
        
        private bool _EnableShowErrorMessage = true;
        [Personalizable(PersonalizationScope.Shared)]
        [WebBrowsable]
        [WebDisplayName("ʾϢ")]
        public bool EnableShowErrorMessage
        {
            get { return _EnableShowErrorMessage; }
            set { _EnableShowErrorMessage = value; }
        }

        protected void RenderError(Exception ex, HtmlTextWriter w)
        {
            if (_EnableShowErrorMessage)
            {
                w.Write(ex.Message);
                w.Write("<br/>");
                w.Write(ex.StackTrace);
                w.Write("<br/>");

                if (ex.InnerException != null)
                    RenderError(ex.InnerException, w);
            }
            else
            {
                w.Write("");
            }
        }

        private IList<Exception> _Exceptions = new  List<Exception>();
        /// <summary>
        /// ¼һ
        /// </summary>
        /// <param name="ex"></param>
        protected void RegisterError(Exception ex)
        {
            _Exceptions.Add(ex);
        }
        /// <summary>
        /// дϢֻһ
        /// </summary>
        /// <param name="w"></param>
        protected void RenderErrors(HtmlTextWriter w)
        {
            if (!_EnableShowErrorMessage)
                return;

            if (_Exceptions.Count == 0) return;

            foreach (Exception ex in _Exceptions)
            {
                w.Write(ex.Message);
                w.Write("<br/>");
                w.Write(ex.StackTrace);
                w.Write("<br/>");
            }

            _Exceptions.Clear();
        }

      

        #endregion

        #region Դȡ


        private SPSite _CurSite;
        /// <summary>
        /// ȡǰվ
        /// </summary>
        /// <returns></returns>
        protected virtual SPSite GetCurrentSPSite()
        {

            if (_CurSite == null)
            {
                if (String.IsNullOrEmpty(SiteUrl))
                {
                    _CurSite = SPContext.Current.Site;
                }
                else
                {
                    _CurSite = new SPSite(SiteUrl);
                }
            }

            return _CurSite;
        }

       

        private SPWeb _CurSPWeb;
        /// <summary>
        /// ȡǰweb
        /// </summary>
        /// <returns></returns>
        protected virtual SPWeb GetCurrentSPWeb()
        {
            if (_CurSPWeb == null)
            {

                if (!String.IsNullOrEmpty(_WebName))
                {
                    _CurSPWeb = GetCurrentSPSite().AllWebs[_WebName];
                }
                else if (GetQueryString(WEB_NAME_QUERYSTRING_KEY) != "")
                {
                    _CurSPWeb = GetCurrentSPSite().AllWebs[GetQueryString(WEB_NAME_QUERYSTRING_KEY)];
                }
                else
                {
                    if (String.IsNullOrEmpty(_SiteUrl))
                        _CurSPWeb = SPContext.Current.Web;
                    else
                        _CurSPWeb = GetCurrentSPSite().RootWeb;
                }
            }

            return _CurSPWeb;
        }

        #endregion

        //public override EditorPartCollection CreateEditorParts()
        //{
        //    ArrayList editorArray = new ArrayList();

        //    SkinEditorPart edPart = new SkinEditorPart();
        //    edPart.ID = this.ID + "_skinEditorPart";
        //    editorArray.Add(edPart);

        //    EditorPartCollection initEditorParts = base.CreateEditorParts();

        //    EditorPartCollection editorParts = new EditorPartCollection(initEditorParts, editorArray);

        //    return editorParts;
        //}

        

    
        

        protected override void RenderContents(HtmlTextWriter writer)
        {
            try
            {
                base.RenderContents(writer);
            }
            catch( Exception ex )
            {
                writer.Write(ex.Message);
            }

            //ͳһĴ
            RenderErrors(writer);
        }
         
   

        protected override void OnUnload(EventArgs e)
        {
            //if (_CurSPWeb != null)
            //    _CurSPWeb.Dispose();

            //if (_CurSite != null)
            //    _CurSite.Dispose();

            base.OnUnload(e);
        }

        protected string GeyShowToolPanelScript()
        {
            return "MSOTlPn_ShowToolPane2Wrapper('Edit','129','"+this.ID+"')";
        }

        protected void RegisterShowToolPanelControl(string msg1, string msg2, string msg3)
        {
            LiteralControl lt = new LiteralControl();
            lt.Text = "<P><DIV class=\"UserGeneric\">"+msg1+"<A HREF=\"javascript:" + GeyShowToolPanelScript() + "\">"+msg2+"</A>"+msg3+"</DIV></P>";
            this.Controls.Add(lt);
        }

        protected void AddHtml(string html)
        {
            LiteralControl lt = new LiteralControl();
            lt.EnableViewState = false;
            lt.Text = html;
            this.Controls.Add(lt);
        }

        protected void AddHtml(string html , Control ctl )
        {
            LiteralControl lt = new LiteralControl();
            lt.EnableViewState = false;
            lt.Text = html;
            ctl.Controls.Add(lt);
        }

  
    }
}
